package com.iconplus.smartproc.model.entity;

import com.iconplus.smartproc.helper.base.BaseEntity;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.hibernate.annotations.Type;

import javax.persistence.*;
import java.sql.Date;

@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@Entity
@Table(name = "drp_rekomendasi")
public class DrpRekomendasi extends BaseEntity {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id")
    private Long id;

    @Column(name = "drp_id")
    private Long drpId;

    @Column(name = "user_id")
    private Long userId;

    @Column(name = "jenis_pengadaan_id")
    private Long jenisPengadaanId;

    @Column(name = "drp_approval_id")
    private Long drpApprovalId;

    @Column(name = "rekomendasi")
    private String rekomendasi;

    @Column(name = "rekomendasi_date")
    private Date rekomendasiDate;

    @Column(name = "is_active")
    @Type(type = "org.hibernate.type.NumericBooleanType")
    private Boolean isActive;

    @Column(name = "is_delete")
    @Type(type = "org.hibernate.type.NumericBooleanType")
    private Boolean isDelete;
}
