package com.iconplus.smartproc.model.entity;

import com.iconplus.smartproc.helper.base.BaseEntity;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.hibernate.annotations.Type;

import javax.persistence.*;

@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@Entity
@Table(name = "rks_isi")
public class RksIsi extends BaseEntity {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id")
    private Long id;

    @Column(name = "rks_daftar_isi_id")
    private Long rksDaftarIsiId;

    @Column(name = "nomor")
    private String nomor;

    @Column(name = "parent_id")
    private Integer parentId;

    @Column(name = "parent")
    private String parent;

    @Column(name = "nama")
    private String nama;

    @Column(name = "bab")
    private String bab;

    @Column(name = "kelompok")
    private String kelompok;

    @Column(name = "sub_bab")
    private String subBab;

    @Column(name = "urutan")
    private String urutan;

    @Column(name = "is_kontrak")
    @Type(type = "org.hibernate.type.NumericBooleanType")
    private Boolean isKontrak;

    @Column(name = "is_active")
    @Type(type = "org.hibernate.type.NumericBooleanType")
    private Boolean isActive;

    @Column(name = "is_delete")
    @Type(type = "org.hibernate.type.NumericBooleanType")
    private Boolean isDelete;

}
