package com.iconplus.smartproc.repository;

import com.iconplus.smartproc.model.entity.RksDaftarIsi;
import com.iconplus.smartproc.model.entity.RksIsi;
import com.iconplus.smartproc.model.projection.RksDaftarIsiView;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Optional;

@Repository
public interface RksDaftarIsiRepository extends JpaRepository<RksDaftarIsi, Long> {

    @Query(value = "SELECT rki.id as id, " +
            "rki.kodeTemplate as kodeTemplate, " +
            "rki.namaTemplate as namaTemplate, " +
            "rki.metodePengadaanId as metodePengadaanId, " +
            "mp.metodePengadaan as metodePengadaan " +
            "FROM RksDaftarIsi rki " +
            "JOIN MetodePengadaan mp ON mp.id = rki.metodePengadaanId " +
            "WHERE rki.isDelete = false " +
            "ORDER BY rki.kodeTemplate")
    Page<RksDaftarIsiView> getListRksDaftarIsi(Pageable pageable);

    Optional<RksDaftarIsi> findByKodeTemplateAndIsDeleteFalse(String kodeTemplate);

    Optional<RksDaftarIsi> findByIdAndIsDeleteFalse(Long id);

}
