package com.iconplus.smartproc.repository;

import com.iconplus.smartproc.model.entity.RksTemplate;
import com.iconplus.smartproc.model.projection.RksTemplateView;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import java.util.Optional;

@Repository
public interface RksTemplateRepository extends JpaRepository<RksTemplate, Long> {

    Optional<RksTemplate> findByKodeTemplateAndIsDeleteFalse(String kodeTemplate);

    Optional<RksTemplate> findByIdAndIsDeleteFalse(Long id);

    @Query(value = "SELECT rt.id as id, " +
            "rt.kodeTemplate as kodeTemplate, " +
            "rt.namaTemplate as namaTemplate, " +
            "rt.metodePengadaanId as metodePengadaanId, " +
            "m.metodePengadaan as metodePengadaan, " +
            "rt.versi as versi, " +
            "rt.rksDaftarIsiId as rksDaftarIsiId, " +
            "rdi.namaTemplate as daftarIsi, " +
            "rt.isActive as isActive " +
            "FROM RksTemplate as rt " +
            "JOIN RksDaftarIsi rdi ON rdi.id = rt.rksDaftarIsiId " +
            "JOIN MetodePengadaan m ON m.id = rt.metodePengadaanId " +
            "WHERE rt.isDelete = 0")
    Page<RksTemplateView> getListRksTemplate(Pageable pageable);

}
