package com.iconplus.smartproc.service.drppengadaan;

import com.iconplus.smartproc.exception.BusinessException;
import com.iconplus.smartproc.helper.model.EmptyResponse;
import com.iconplus.smartproc.helper.service.BaseService;
import com.iconplus.smartproc.model.request.DrpPengadaanRequest;
import com.iconplus.smartproc.repository.DrpPengadaanRepository;
import com.iconplus.smartproc.util.Constants;
import org.springframework.stereotype.Service;


@Service
public class DeleteDrpPengadaanService implements BaseService<DrpPengadaanRequest, EmptyResponse> {

    private DrpPengadaanRepository drpPengadaanRepository;
    public DeleteDrpPengadaanService(DrpPengadaanRepository drpPengadaanRepository) {
        this.drpPengadaanRepository = drpPengadaanRepository;
    }

    @Override
    public EmptyResponse execute(DrpPengadaanRequest input) {

        var drpPengadaan = drpPengadaanRepository.findByIdAndIsDeleteFalse(input.getId())
                .orElseThrow(() -> new BusinessException(Constants.ERR_CODE_10001,
                        Constants.ERR_TTL_10001,
                        String.format(Constants.ERR_MSG_10001, "DRP", input.getId())));

        drpPengadaan.setIsDelete(true);
        drpPengadaanRepository.save(drpPengadaan);
        return new EmptyResponse();
    }
}
