package com.iconplus.smartproc.service.rksdaftarisi;

import com.iconplus.smartproc.exception.BusinessException;
import com.iconplus.smartproc.helper.model.EmptyResponse;
import com.iconplus.smartproc.helper.service.BaseService;
import com.iconplus.smartproc.model.request.RksDaftarIsiRequest;
import com.iconplus.smartproc.repository.RksDaftarIsiRepository;
import com.iconplus.smartproc.repository.RksIsiRepository;
import com.iconplus.smartproc.util.Constants;
import org.springframework.stereotype.Service;

@Service
public class DeleteRksDaftarIsiService implements BaseService<RksDaftarIsiRequest, EmptyResponse> {

    private final RksDaftarIsiRepository rksDaftarIsiRepository;
    private final RksIsiRepository rksIsiRepository;
    public DeleteRksDaftarIsiService(RksDaftarIsiRepository rksDaftarIsiRepository,
                                     RksIsiRepository rksIsiRepository) {
        this.rksDaftarIsiRepository = rksDaftarIsiRepository;
        this.rksIsiRepository = rksIsiRepository;
    }

    @Override
    public EmptyResponse execute(RksDaftarIsiRequest input) {

        var rksDaftarIsi= rksDaftarIsiRepository.findByIdAndIsDeleteFalse(input.getId())
                .orElseThrow(() -> new BusinessException(Constants.ERR_CODE_10001,
                        Constants.ERR_TTL_10001,
                        String.format(Constants.ERR_MSG_10001, "RKS Daftar Isi", input.getId())));

        rksDaftarIsi.setIsDelete(true);
        rksDaftarIsiRepository.save(rksDaftarIsi);
        rksIsiRepository.deleteRksIsi(rksDaftarIsi.getId());

        return new EmptyResponse();
    }
}
