package com.iconplus.smartproc.service.rksdaftarisi;

import com.iconplus.smartproc.exception.BusinessException;
import com.iconplus.smartproc.helper.model.EmptyResponse;
import com.iconplus.smartproc.helper.service.BaseService;
import com.iconplus.smartproc.model.request.RksIsiRequest;
import com.iconplus.smartproc.repository.RksIsiRepository;
import com.iconplus.smartproc.util.Constants;
import org.springframework.stereotype.Service;

@Service
public class DeleteRksIsiService implements BaseService<RksIsiRequest, EmptyResponse> {

    private final RksIsiRepository rksIsiRepository;
    public DeleteRksIsiService(RksIsiRepository rksIsiRepository) {
        this.rksIsiRepository = rksIsiRepository;
    }

    @Override
    public EmptyResponse execute(RksIsiRequest input) {

        var rksIsi = rksIsiRepository.findByIdAndIsDeleteFalse(input.getId())
                .orElseThrow(() -> new BusinessException(
                        Constants.ERR_CODE_10001,
                        Constants.ERR_TTL_10001,
                        String.format(Constants.ERR_MSG_10001, "RKS Isi", input.getId())
                ));

        rksIsi.setIsDelete(true);
        rksIsiRepository.save(rksIsi);
        return new EmptyResponse();
    }
}
