package com.iconplus.smartproc.service.rksdaftarisi;

import com.iconplus.smartproc.helper.service.BaseService;
import com.iconplus.smartproc.model.entity.RksIsi;
import com.iconplus.smartproc.model.request.RksIsiRequest;
import com.iconplus.smartproc.model.response.ListRksIsiResponse;
import com.iconplus.smartproc.model.response.RksIsiResponse;
import com.iconplus.smartproc.repository.RksDaftarIsiRepository;
import com.iconplus.smartproc.repository.RksIsiRepository;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service
public class GetListRksParentService implements BaseService<RksIsiRequest, ListRksIsiResponse> {

    private final RksIsiRepository rksIsiRepository;
    public GetListRksParentService(RksIsiRepository rksIsiRepository) {
        this.rksIsiRepository = rksIsiRepository;
    }

    @Override
    public ListRksIsiResponse execute(RksIsiRequest input) {

        List<RksIsiResponse> rksIsiResponseList = new ArrayList<>();
        var rksIsiList = rksIsiRepository.findByRksDaftarIsiIdAndIsDeleteFalse(input.getRksDaftarIsiId());

        for (RksIsi rksIsi : rksIsiList) {
            RksIsiResponse rksIsiResponse = RksIsiResponse.builder()
                    .id(rksIsi.getId())
                    .parent(rksIsi.getNama())
                    .build();
            rksIsiResponseList.add(rksIsiResponse);
        }

        return ListRksIsiResponse.builder()
                .data(rksIsiResponseList)
                .build();
    }
}
