package com.iconplus.smartproc.service.rksdaftarisi;

import com.iconplus.smartproc.exception.BusinessException;
import com.iconplus.smartproc.helper.service.BaseService;
import com.iconplus.smartproc.model.request.RksDaftarIsiRequest;
import com.iconplus.smartproc.model.response.RksDaftarIsiResponse;
import com.iconplus.smartproc.repository.RksDaftarIsiRepository;
import com.iconplus.smartproc.util.Constants;
import org.springframework.stereotype.Service;

@Service
public class PutUpdateRksDaftarIsiService implements BaseService<RksDaftarIsiRequest, RksDaftarIsiResponse> {

    private final RksDaftarIsiRepository rksDaftarIsiRepository;
    public PutUpdateRksDaftarIsiService(RksDaftarIsiRepository rksDaftarIsiRepository) {
        this.rksDaftarIsiRepository = rksDaftarIsiRepository;
    }

    @Override
    public RksDaftarIsiResponse execute(RksDaftarIsiRequest input) {

        var rksDaftarIsi= rksDaftarIsiRepository.findByIdAndIsDeleteFalse(input.getId())
                .orElseThrow(() -> new BusinessException(Constants.ERR_CODE_10001,
                        Constants.ERR_TTL_10001,
                        String.format(Constants.ERR_MSG_10001, "RKS Daftar Isi", input.getId())));

        rksDaftarIsi.setKodeTemplate(input.getKodeTemplate());
        rksDaftarIsi.setNamaTemplate(input.getNamaTemplate());
        rksDaftarIsi.setMetodePengadaanId(input.getMetodePengadaanId());
        rksDaftarIsi.setVersi(input.getVersi());

        rksDaftarIsiRepository.save(rksDaftarIsi);

        return RksDaftarIsiResponse.builder()
                .id(rksDaftarIsi.getId())
                .build();
    }
}
